/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumLogicvalidreason;
import de.ship.db.tables.records.VDmLogicRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDmLogic extends TableImpl<VDmLogicRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dm_logic</code>
     */
    public static final VDmLogic V_DM_LOGIC = new VDmLogic();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDmLogicRecord> getRecordType() {
        return VDmLogicRecord.class;
    }

    /**
     * The column <code>common_dd.v_dm_logic.key_element</code>.
     */
    public final TableField<VDmLogicRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_logic.logictype_descr</code>.
     */
    public final TableField<VDmLogicRecord, String> LOGICTYPE_DESCR = createField(DSL.name("logictype_descr"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_logic.varname</code>.
     */
    public final TableField<VDmLogicRecord, String> VARNAME = createField(DSL.name("varname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_logic.condition</code>.
     */
    public final TableField<VDmLogicRecord, String> CONDITION = createField(DSL.name("condition"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_logic.variable_stage</code>.
     */
    public final TableField<VDmLogicRecord, Integer> VARIABLE_STAGE = createField(DSL.name("variable_stage"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_logic.varname_dn</code>.
     */
    public final TableField<VDmLogicRecord, String> VARNAME_DN = createField(DSL.name("varname_dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_logic.condition_dn</code>.
     */
    public final TableField<VDmLogicRecord, String> CONDITION_DN = createField(DSL.name("condition_dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_logic.valid_from</code>.
     */
    public final TableField<VDmLogicRecord, LocalDateTime> VALID_FROM = createField(DSL.name("valid_from"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_dm_logic.valid_until</code>.
     */
    public final TableField<VDmLogicRecord, LocalDateTime> VALID_UNTIL = createField(DSL.name("valid_until"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_dm_logic.active</code>.
     */
    public final TableField<VDmLogicRecord, Boolean> ACTIVE = createField(DSL.name("active"), SQLDataType.BOOLEAN, this, "");

    /**
     * The column <code>common_dd.v_dm_logic.valid_reason</code>.
     */
    public final TableField<VDmLogicRecord, EnumLogicvalidreason> VALID_REASON = createField(DSL.name("valid_reason"), SQLDataType.VARCHAR.asEnumDataType(EnumLogicvalidreason.class), this, "");

    /**
     * The column <code>common_dd.v_dm_logic.valid_comment</code>.
     */
    public final TableField<VDmLogicRecord, String> VALID_COMMENT = createField(DSL.name("valid_comment"), SQLDataType.CLOB, this, "");

    private VDmLogic(Name alias, Table<VDmLogicRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDmLogic(Name alias, Table<VDmLogicRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dm_logic" as  SELECT key_element,
          logictype_descr,
          varname,
          condition,
          variable_stage,
          varname_dn,
          condition_dn,
          valid_from,
          valid_until,
          active,
          valid_reason,
          valid_comment
         FROM ( SELECT logic_partitioned.row_nr,
                  logic_partitioned.prev_reason,
                  logic_partitioned.key_element,
                  logic_partitioned.logictype_descr,
                  logic_partitioned.varname,
                  logic_partitioned.condition,
                  logic_partitioned.variable_stage,
                  logic_partitioned.varname_dn,
                  logic_partitioned.condition_dn,
                  first_value(logic_partitioned.valid_from) OVER w AS valid_from,
                  logic_partitioned.valid_until,
                  logic_partitioned.active,
                  logic_partitioned.valid_reason,
                  logic_partitioned.valid_comment
                 FROM ( SELECT logic_ordered.row_nr,
                          logic_ordered.prev_reason,
                          logic_ordered.key_element,
                          logic_ordered.logictype_descr,
                          logic_ordered.varname,
                          logic_ordered.condition,
                          logic_ordered.variable_stage,
                          logic_ordered.varname_dn,
                          logic_ordered.condition_dn,
                          logic_ordered.valid_from,
                          logic_ordered.valid_until,
                          logic_ordered.active,
                          logic_ordered.valid_reason,
                          logic_ordered.valid_comment,
                          sum(
                              CASE
                                  WHEN (logic_ordered.prev_reason = 'bugfix'::common_dd.enum_logicvalidreason) THEN 0
                                  ELSE 1
                              END) OVER (ORDER BY logic_ordered.row_nr) AS value_partition
                         FROM ( SELECT row_number() OVER w AS row_nr,
                                  lag(v_core_logic.valid_reason) OVER w AS prev_reason,
                                  v_core_logic.key_element,
                                  v_core_logic.logictype_descr,
                                  v_core_logic.varname,
                                  v_core_logic.condition,
                                  v_core_logic.variable_stage,
                                  v_core_logic.varname_dn,
                                  v_core_logic.condition_dn,
                                  v_core_logic.valid_from,
                                  v_core_logic.valid_until,
                                  v_core_logic.active,
                                  v_core_logic.valid_reason,
                                  v_core_logic.valid_comment
                                 FROM common_dd.v_core_logic
                                WINDOW w AS (ORDER BY v_core_logic.key_element, v_core_logic.logictype_descr, v_core_logic.valid_from NULLS FIRST, v_core_logic.valid_until)) logic_ordered) logic_partitioned
                WINDOW w AS (PARTITION BY logic_partitioned.value_partition ORDER BY logic_partitioned.row_nr)
                ORDER BY logic_partitioned.row_nr) logic_reduced
        WHERE ((valid_reason = 'change'::common_dd.enum_logicvalidreason) OR (valid_reason IS NULL));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_logic</code> table reference
     */
    public VDmLogic(String alias) {
        this(DSL.name(alias), V_DM_LOGIC);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_logic</code> table reference
     */
    public VDmLogic(Name alias) {
        this(alias, V_DM_LOGIC);
    }

    /**
     * Create a <code>common_dd.v_dm_logic</code> table reference
     */
    public VDmLogic() {
        this(DSL.name("v_dm_logic"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDmLogic as(String alias) {
        return new VDmLogic(DSL.name(alias), this);
    }

    @Override
    public VDmLogic as(Name alias) {
        return new VDmLogic(alias, this);
    }

    @Override
    public VDmLogic as(Table<?> alias) {
        return new VDmLogic(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmLogic rename(String name) {
        return new VDmLogic(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmLogic rename(Name name) {
        return new VDmLogic(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmLogic rename(Table<?> name) {
        return new VDmLogic(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmLogic where(Condition condition) {
        return new VDmLogic(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmLogic where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmLogic where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmLogic where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmLogic where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmLogic where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmLogic where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmLogic where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmLogic whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmLogic whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
